/*******************************************************************************
* File Name: BuzzerPin.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_BuzzerPin_H) /* Pins BuzzerPin_H */
#define CY_PINS_BuzzerPin_H

#include "cytypes.h"
#include "cyfitter.h"
#include "BuzzerPin_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    BuzzerPin_Write(uint8 value) ;
void    BuzzerPin_SetDriveMode(uint8 mode) ;
uint8   BuzzerPin_ReadDataReg(void) ;
uint8   BuzzerPin_Read(void) ;
uint8   BuzzerPin_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define BuzzerPin_DRIVE_MODE_BITS        (3)
#define BuzzerPin_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - BuzzerPin_DRIVE_MODE_BITS))

#define BuzzerPin_DM_ALG_HIZ         (0x00u)
#define BuzzerPin_DM_DIG_HIZ         (0x01u)
#define BuzzerPin_DM_RES_UP          (0x02u)
#define BuzzerPin_DM_RES_DWN         (0x03u)
#define BuzzerPin_DM_OD_LO           (0x04u)
#define BuzzerPin_DM_OD_HI           (0x05u)
#define BuzzerPin_DM_STRONG          (0x06u)
#define BuzzerPin_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define BuzzerPin_MASK               BuzzerPin__MASK
#define BuzzerPin_SHIFT              BuzzerPin__SHIFT
#define BuzzerPin_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define BuzzerPin_PS                     (* (reg32 *) BuzzerPin__PS)
/* Port Configuration */
#define BuzzerPin_PC                     (* (reg32 *) BuzzerPin__PC)
/* Data Register */
#define BuzzerPin_DR                     (* (reg32 *) BuzzerPin__DR)
/* Input Buffer Disable Override */
#define BuzzerPin_INP_DIS                (* (reg32 *) BuzzerPin__PC2)


#if defined(BuzzerPin__INTSTAT)  /* Interrupt Registers */

    #define BuzzerPin_INTSTAT                (* (reg32 *) BuzzerPin__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define BuzzerPin_DRIVE_MODE_SHIFT       (0x00u)
#define BuzzerPin_DRIVE_MODE_MASK        (0x07u << BuzzerPin_DRIVE_MODE_SHIFT)


#endif /* End Pins BuzzerPin_H */


/* [] END OF FILE */
