/*******************************************************************************
* File Name: ENCB.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_ENCB_H) /* Pins ENCB_H */
#define CY_PINS_ENCB_H

#include "cytypes.h"
#include "cyfitter.h"
#include "ENCB_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    ENCB_Write(uint8 value) ;
void    ENCB_SetDriveMode(uint8 mode) ;
uint8   ENCB_ReadDataReg(void) ;
uint8   ENCB_Read(void) ;
uint8   ENCB_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define ENCB_DRIVE_MODE_BITS        (3)
#define ENCB_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - ENCB_DRIVE_MODE_BITS))

#define ENCB_DM_ALG_HIZ         (0x00u)
#define ENCB_DM_DIG_HIZ         (0x01u)
#define ENCB_DM_RES_UP          (0x02u)
#define ENCB_DM_RES_DWN         (0x03u)
#define ENCB_DM_OD_LO           (0x04u)
#define ENCB_DM_OD_HI           (0x05u)
#define ENCB_DM_STRONG          (0x06u)
#define ENCB_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define ENCB_MASK               ENCB__MASK
#define ENCB_SHIFT              ENCB__SHIFT
#define ENCB_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define ENCB_PS                     (* (reg32 *) ENCB__PS)
/* Port Configuration */
#define ENCB_PC                     (* (reg32 *) ENCB__PC)
/* Data Register */
#define ENCB_DR                     (* (reg32 *) ENCB__DR)
/* Input Buffer Disable Override */
#define ENCB_INP_DIS                (* (reg32 *) ENCB__PC2)


#if defined(ENCB__INTSTAT)  /* Interrupt Registers */

    #define ENCB_INTSTAT                (* (reg32 *) ENCB__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define ENCB_DRIVE_MODE_SHIFT       (0x00u)
#define ENCB_DRIVE_MODE_MASK        (0x07u << ENCB_DRIVE_MODE_SHIFT)


#endif /* End Pins ENCB_H */


/* [] END OF FILE */
