/*******************************************************************************
* File Name: PinOutA.h  
* Version 2.5
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_PinOutA_H) /* Pins PinOutA_H */
#define CY_PINS_PinOutA_H

#include "cytypes.h"
#include "cyfitter.h"
#include "PinOutA_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    PinOutA_Write(uint8 value) ;
void    PinOutA_SetDriveMode(uint8 mode) ;
uint8   PinOutA_ReadDataReg(void) ;
uint8   PinOutA_Read(void) ;
uint8   PinOutA_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PinOutA_DRIVE_MODE_BITS        (3)
#define PinOutA_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - PinOutA_DRIVE_MODE_BITS))
#define PinOutA_DRIVE_MODE_SHIFT       (0x00u)
#define PinOutA_DRIVE_MODE_MASK        (0x07u << PinOutA_DRIVE_MODE_SHIFT)

#define PinOutA_DM_ALG_HIZ         (0x00u << PinOutA_DRIVE_MODE_SHIFT)
#define PinOutA_DM_DIG_HIZ         (0x01u << PinOutA_DRIVE_MODE_SHIFT)
#define PinOutA_DM_RES_UP          (0x02u << PinOutA_DRIVE_MODE_SHIFT)
#define PinOutA_DM_RES_DWN         (0x03u << PinOutA_DRIVE_MODE_SHIFT)
#define PinOutA_DM_OD_LO           (0x04u << PinOutA_DRIVE_MODE_SHIFT)
#define PinOutA_DM_OD_HI           (0x05u << PinOutA_DRIVE_MODE_SHIFT)
#define PinOutA_DM_STRONG          (0x06u << PinOutA_DRIVE_MODE_SHIFT)
#define PinOutA_DM_RES_UPDWN       (0x07u << PinOutA_DRIVE_MODE_SHIFT)

/* Digital Port Constants */
#define PinOutA_MASK               PinOutA__MASK
#define PinOutA_SHIFT              PinOutA__SHIFT
#define PinOutA_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PinOutA_PS                     (* (reg32 *) PinOutA__PS)
/* Port Configuration */
#define PinOutA_PC                     (* (reg32 *) PinOutA__PC)
/* Data Register */
#define PinOutA_DR                     (* (reg32 *) PinOutA__DR)
/* Input Buffer Disable Override */
#define PinOutA_INP_DIS                (* (reg32 *) PinOutA__PC2)


#if defined(PinOutA__INTSTAT)  /* Interrupt Registers */

    #define PinOutA_INTSTAT                (* (reg32 *) PinOutA__INTSTAT)

#endif /* Interrupt Registers */

#endif /* End Pins PinOutA_H */


/* [] END OF FILE */
