/*******************************************************************************
* File Name: PinOutTc.h  
* Version 2.5
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_PinOutTc_H) /* Pins PinOutTc_H */
#define CY_PINS_PinOutTc_H

#include "cytypes.h"
#include "cyfitter.h"
#include "PinOutTc_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    PinOutTc_Write(uint8 value) ;
void    PinOutTc_SetDriveMode(uint8 mode) ;
uint8   PinOutTc_ReadDataReg(void) ;
uint8   PinOutTc_Read(void) ;
uint8   PinOutTc_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PinOutTc_DRIVE_MODE_BITS        (3)
#define PinOutTc_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - PinOutTc_DRIVE_MODE_BITS))
#define PinOutTc_DRIVE_MODE_SHIFT       (0x00u)
#define PinOutTc_DRIVE_MODE_MASK        (0x07u << PinOutTc_DRIVE_MODE_SHIFT)

#define PinOutTc_DM_ALG_HIZ         (0x00u << PinOutTc_DRIVE_MODE_SHIFT)
#define PinOutTc_DM_DIG_HIZ         (0x01u << PinOutTc_DRIVE_MODE_SHIFT)
#define PinOutTc_DM_RES_UP          (0x02u << PinOutTc_DRIVE_MODE_SHIFT)
#define PinOutTc_DM_RES_DWN         (0x03u << PinOutTc_DRIVE_MODE_SHIFT)
#define PinOutTc_DM_OD_LO           (0x04u << PinOutTc_DRIVE_MODE_SHIFT)
#define PinOutTc_DM_OD_HI           (0x05u << PinOutTc_DRIVE_MODE_SHIFT)
#define PinOutTc_DM_STRONG          (0x06u << PinOutTc_DRIVE_MODE_SHIFT)
#define PinOutTc_DM_RES_UPDWN       (0x07u << PinOutTc_DRIVE_MODE_SHIFT)

/* Digital Port Constants */
#define PinOutTc_MASK               PinOutTc__MASK
#define PinOutTc_SHIFT              PinOutTc__SHIFT
#define PinOutTc_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PinOutTc_PS                     (* (reg32 *) PinOutTc__PS)
/* Port Configuration */
#define PinOutTc_PC                     (* (reg32 *) PinOutTc__PC)
/* Data Register */
#define PinOutTc_DR                     (* (reg32 *) PinOutTc__DR)
/* Input Buffer Disable Override */
#define PinOutTc_INP_DIS                (* (reg32 *) PinOutTc__PC2)


#if defined(PinOutTc__INTSTAT)  /* Interrupt Registers */

    #define PinOutTc_INTSTAT                (* (reg32 *) PinOutTc__INTSTAT)

#endif /* Interrupt Registers */

#endif /* End Pins PinOutTc_H */


/* [] END OF FILE */
