/*******************************************************************************
* File Name: SCBUART_rx.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_SCBUART_rx_H) /* Pins SCBUART_rx_H */
#define CY_PINS_SCBUART_rx_H

#include "cytypes.h"
#include "cyfitter.h"
#include "SCBUART_rx_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    SCBUART_rx_Write(uint8 value) ;
void    SCBUART_rx_SetDriveMode(uint8 mode) ;
uint8   SCBUART_rx_ReadDataReg(void) ;
uint8   SCBUART_rx_Read(void) ;
uint8   SCBUART_rx_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define SCBUART_rx_DRIVE_MODE_BITS        (3)
#define SCBUART_rx_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - SCBUART_rx_DRIVE_MODE_BITS))
#define SCBUART_rx_DRIVE_MODE_SHIFT       (0x00u)
#define SCBUART_rx_DRIVE_MODE_MASK        (0x07u << SCBUART_rx_DRIVE_MODE_SHIFT)

#define SCBUART_rx_DM_ALG_HIZ         (0x00u << SCBUART_rx_DRIVE_MODE_SHIFT)
#define SCBUART_rx_DM_DIG_HIZ         (0x01u << SCBUART_rx_DRIVE_MODE_SHIFT)
#define SCBUART_rx_DM_RES_UP          (0x02u << SCBUART_rx_DRIVE_MODE_SHIFT)
#define SCBUART_rx_DM_RES_DWN         (0x03u << SCBUART_rx_DRIVE_MODE_SHIFT)
#define SCBUART_rx_DM_OD_LO           (0x04u << SCBUART_rx_DRIVE_MODE_SHIFT)
#define SCBUART_rx_DM_OD_HI           (0x05u << SCBUART_rx_DRIVE_MODE_SHIFT)
#define SCBUART_rx_DM_STRONG          (0x06u << SCBUART_rx_DRIVE_MODE_SHIFT)
#define SCBUART_rx_DM_RES_UPDWN       (0x07u << SCBUART_rx_DRIVE_MODE_SHIFT)

/* Digital Port Constants */
#define SCBUART_rx_MASK               SCBUART_rx__MASK
#define SCBUART_rx_SHIFT              SCBUART_rx__SHIFT
#define SCBUART_rx_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define SCBUART_rx_PS                     (* (reg32 *) SCBUART_rx__PS)
/* Port Configuration */
#define SCBUART_rx_PC                     (* (reg32 *) SCBUART_rx__PC)
/* Data Register */
#define SCBUART_rx_DR                     (* (reg32 *) SCBUART_rx__DR)
/* Input Buffer Disable Override */
#define SCBUART_rx_INP_DIS                (* (reg32 *) SCBUART_rx__PC2)


#if defined(SCBUART_rx__INTSTAT)  /* Interrupt Registers */

    #define SCBUART_rx_INTSTAT                (* (reg32 *) SCBUART_rx__INTSTAT)

#endif /* Interrupt Registers */

#endif /* End Pins SCBUART_rx_H */


/* [] END OF FILE */
