/*******************************************************************************
* File Name: TestB.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_TestB_H) /* Pins TestB_H */
#define CY_PINS_TestB_H

#include "cytypes.h"
#include "cyfitter.h"
#include "TestB_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    TestB_Write(uint8 value) ;
void    TestB_SetDriveMode(uint8 mode) ;
uint8   TestB_ReadDataReg(void) ;
uint8   TestB_Read(void) ;
uint8   TestB_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define TestB_DRIVE_MODE_BITS        (3)
#define TestB_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - TestB_DRIVE_MODE_BITS))

#define TestB_DM_ALG_HIZ         (0x00u)
#define TestB_DM_DIG_HIZ         (0x01u)
#define TestB_DM_RES_UP          (0x02u)
#define TestB_DM_RES_DWN         (0x03u)
#define TestB_DM_OD_LO           (0x04u)
#define TestB_DM_OD_HI           (0x05u)
#define TestB_DM_STRONG          (0x06u)
#define TestB_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define TestB_MASK               TestB__MASK
#define TestB_SHIFT              TestB__SHIFT
#define TestB_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define TestB_PS                     (* (reg32 *) TestB__PS)
/* Port Configuration */
#define TestB_PC                     (* (reg32 *) TestB__PC)
/* Data Register */
#define TestB_DR                     (* (reg32 *) TestB__DR)
/* Input Buffer Disable Override */
#define TestB_INP_DIS                (* (reg32 *) TestB__PC2)


#if defined(TestB__INTSTAT)  /* Interrupt Registers */

    #define TestB_INTSTAT                (* (reg32 *) TestB__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define TestB_DRIVE_MODE_SHIFT       (0x00u)
#define TestB_DRIVE_MODE_MASK        (0x07u << TestB_DRIVE_MODE_SHIFT)


#endif /* End Pins TestB_H */


/* [] END OF FILE */
