/*******************************************************************************
* File Name: TestTimer.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_TestTimer_H) /* Pins TestTimer_H */
#define CY_PINS_TestTimer_H

#include "cytypes.h"
#include "cyfitter.h"
#include "TestTimer_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    TestTimer_Write(uint8 value) ;
void    TestTimer_SetDriveMode(uint8 mode) ;
uint8   TestTimer_ReadDataReg(void) ;
uint8   TestTimer_Read(void) ;
uint8   TestTimer_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define TestTimer_DRIVE_MODE_BITS        (3)
#define TestTimer_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - TestTimer_DRIVE_MODE_BITS))

#define TestTimer_DM_ALG_HIZ         (0x00u)
#define TestTimer_DM_DIG_HIZ         (0x01u)
#define TestTimer_DM_RES_UP          (0x02u)
#define TestTimer_DM_RES_DWN         (0x03u)
#define TestTimer_DM_OD_LO           (0x04u)
#define TestTimer_DM_OD_HI           (0x05u)
#define TestTimer_DM_STRONG          (0x06u)
#define TestTimer_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define TestTimer_MASK               TestTimer__MASK
#define TestTimer_SHIFT              TestTimer__SHIFT
#define TestTimer_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define TestTimer_PS                     (* (reg32 *) TestTimer__PS)
/* Port Configuration */
#define TestTimer_PC                     (* (reg32 *) TestTimer__PC)
/* Data Register */
#define TestTimer_DR                     (* (reg32 *) TestTimer__DR)
/* Input Buffer Disable Override */
#define TestTimer_INP_DIS                (* (reg32 *) TestTimer__PC2)


#if defined(TestTimer__INTSTAT)  /* Interrupt Registers */

    #define TestTimer_INTSTAT                (* (reg32 *) TestTimer__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define TestTimer_DRIVE_MODE_SHIFT       (0x00u)
#define TestTimer_DRIVE_MODE_MASK        (0x07u << TestTimer_DRIVE_MODE_SHIFT)


#endif /* End Pins TestTimer_H */


/* [] END OF FILE */
