/*******************************************************************************
* File Name: isrPinSW.c  
* Version 1.70
*
*  Description:
*   API for controlling the state of an interrupt.
*
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/


#include <cydevice_trm.h>
#include <CyLib.h>
#include <isrPinSW.h>

#if !defined(isrPinSW__REMOVED) /* Check for removal by optimization */

/*******************************************************************************
*  Place your includes, defines and code here 
********************************************************************************/
/* `#START isrPinSW_intc` */

/* `#END` */

extern cyisraddress CyRamVectors[CYINT_IRQ_BASE + CY_NUM_INTERRUPTS];

/* Declared in startup, used to set unused interrupts to. */
CY_ISR_PROTO(IntDefaultHandler);


/*******************************************************************************
* Function Name: isrPinSW_Start
********************************************************************************
*
* Summary:
*  Set up the interrupt and enable it.
*
* Parameters:  
*   None
*
* Return:
*   None
*
*******************************************************************************/
void isrPinSW_Start(void)
{
    /* For all we know the interrupt is active. */
    isrPinSW_Disable();

    /* Set the ISR to point to the isrPinSW Interrupt. */
    isrPinSW_SetVector(&isrPinSW_Interrupt);

    /* Set the priority. */
    isrPinSW_SetPriority((uint8)isrPinSW_INTC_PRIOR_NUMBER);

    /* Enable it. */
    isrPinSW_Enable();
}


/*******************************************************************************
* Function Name: isrPinSW_StartEx
********************************************************************************
*
* Summary:
*  Set up the interrupt and enable it.
*
* Parameters:  
*   address: Address of the ISR to set in the interrupt vector table.
*
* Return:
*   None
*
*******************************************************************************/
void isrPinSW_StartEx(cyisraddress address)
{
    /* For all we know the interrupt is active. */
    isrPinSW_Disable();

    /* Set the ISR to point to the isrPinSW Interrupt. */
    isrPinSW_SetVector(address);

    /* Set the priority. */
    isrPinSW_SetPriority((uint8)isrPinSW_INTC_PRIOR_NUMBER);

    /* Enable it. */
    isrPinSW_Enable();
}


/*******************************************************************************
* Function Name: isrPinSW_Stop
********************************************************************************
*
* Summary:
*   Disables and removes the interrupt.
*
* Parameters:  
*
* Return:
*   None
*
*******************************************************************************/
void isrPinSW_Stop(void)
{
    /* Disable this interrupt. */
    isrPinSW_Disable();

    /* Set the ISR to point to the passive one. */
    isrPinSW_SetVector(&IntDefaultHandler);
}


/*******************************************************************************
* Function Name: isrPinSW_Interrupt
********************************************************************************
*
* Summary:
*   The default Interrupt Service Routine for isrPinSW.
*
*   Add custom code between the coments to keep the next version of this file
*   from over writting your code.
*
* Parameters:  
*   None
*
* Return:
*   None
*
*******************************************************************************/
CY_ISR(isrPinSW_Interrupt)
{
    /*  Place your Interrupt code here. */
    /* `#START isrPinSW_Interrupt` */

    /* `#END` */
}


/*******************************************************************************
* Function Name: isrPinSW_SetVector
********************************************************************************
*
* Summary:
*   Change the ISR vector for the Interrupt. Note calling isrPinSW_Start
*   will override any effect this method would have had. To set the vector 
*   before the component has been started use isrPinSW_StartEx instead.
*
* Parameters:
*   address: Address of the ISR to set in the interrupt vector table.
*
* Return:
*   None
*
*******************************************************************************/
void isrPinSW_SetVector(cyisraddress address)
{
    CyRamVectors[CYINT_IRQ_BASE + isrPinSW__INTC_NUMBER] = address;
}


/*******************************************************************************
* Function Name: isrPinSW_GetVector
********************************************************************************
*
* Summary:
*   Gets the "address" of the current ISR vector for the Interrupt.
*
* Parameters:
*   None
*
* Return:
*   Address of the ISR in the interrupt vector table.
*
*******************************************************************************/
cyisraddress isrPinSW_GetVector(void)
{
    return CyRamVectors[CYINT_IRQ_BASE + isrPinSW__INTC_NUMBER];
}


/*******************************************************************************
* Function Name: isrPinSW_SetPriority
********************************************************************************
*
* Summary:
*   Sets the Priority of the Interrupt. Note calling isrPinSW_Start
*   or isrPinSW_StartEx will override any effect this method would 
*   have had. This method should only be called after isrPinSW_Start or 
*   isrPinSW_StartEx has been called. To set the initial
*   priority for the component use the cydwr file in the tool.
*
* Parameters:
*   priority: Priority of the interrupt. 0 - 3, 0 being the highest.
*
* Return:
*   None
*
*******************************************************************************/
void isrPinSW_SetPriority(uint8 priority)
{
	uint8 interruptState;
    uint32 priorityOffset = ((isrPinSW__INTC_NUMBER % 4u) * 8u) + 6u;
    
	interruptState = CyEnterCriticalSection();
    *isrPinSW_INTC_PRIOR = (*isrPinSW_INTC_PRIOR & (uint32)(~isrPinSW__INTC_PRIOR_MASK)) |
                                    ((uint32)priority << priorityOffset);
	CyExitCriticalSection(interruptState);
}


/*******************************************************************************
* Function Name: isrPinSW_GetPriority
********************************************************************************
*
* Summary:
*   Gets the Priority of the Interrupt.
*
* Parameters:
*   None
*
* Return:
*   Priority of the interrupt. 0 - 3, 0 being the highest.
*
*******************************************************************************/
uint8 isrPinSW_GetPriority(void)
{
    uint32 priority;
	uint32 priorityOffset = ((isrPinSW__INTC_NUMBER % 4u) * 8u) + 6u;

    priority = (*isrPinSW_INTC_PRIOR & isrPinSW__INTC_PRIOR_MASK) >> priorityOffset;

    return (uint8)priority;
}


/*******************************************************************************
* Function Name: isrPinSW_Enable
********************************************************************************
*
* Summary:
*   Enables the interrupt.
*
* Parameters:
*   None
*
* Return:
*   None
*
*******************************************************************************/
void isrPinSW_Enable(void)
{
    /* Enable the general interrupt. */
    *isrPinSW_INTC_SET_EN = isrPinSW__INTC_MASK;
}


/*******************************************************************************
* Function Name: isrPinSW_GetState
********************************************************************************
*
* Summary:
*   Gets the state (enabled, disabled) of the Interrupt.
*
* Parameters:
*   None
*
* Return:
*   1 if enabled, 0 if disabled.
*
*******************************************************************************/
uint8 isrPinSW_GetState(void)
{
    /* Get the state of the general interrupt. */
    return ((*isrPinSW_INTC_SET_EN & (uint32)isrPinSW__INTC_MASK) != 0u) ? 1u:0u;
}


/*******************************************************************************
* Function Name: isrPinSW_Disable
********************************************************************************
*
* Summary:
*   Disables the Interrupt.
*
* Parameters:
*   None
*
* Return:
*   None
*
*******************************************************************************/
void isrPinSW_Disable(void)
{
    /* Disable the general interrupt. */
    *isrPinSW_INTC_CLR_EN = isrPinSW__INTC_MASK;
}


/*******************************************************************************
* Function Name: isrPinSW_SetPending
********************************************************************************
*
* Summary:
*   Causes the Interrupt to enter the pending state, a software method of
*   generating the interrupt.
*
* Parameters:
*   None
*
* Return:
*   None
*
*******************************************************************************/
void isrPinSW_SetPending(void)
{
    *isrPinSW_INTC_SET_PD = isrPinSW__INTC_MASK;
}


/*******************************************************************************
* Function Name: isrPinSW_ClearPending
********************************************************************************
*
* Summary:
*   Clears a pending interrupt.
*
* Parameters:
*   None
*
* Return:
*   None
*
*******************************************************************************/
void isrPinSW_ClearPending(void)
{
    *isrPinSW_INTC_CLR_PD = isrPinSW__INTC_MASK;
}

#endif /* End check for removal by optimization */


/* [] END OF FILE */
