
/**
 * @file encoder_sw_single.h    
 * @author  Reiner Wehner 
 * @date    03.06.2015 - first implement
 *
 * @section LICENSE
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details at
 * https://www.gnu.org/copyleft/gpl.html
 *
 * @section header file for encoder functionality
 *
 * @todo
 *
 * @version 1.0
 */
				
#ifndef ENCODER_SW_SINGLE_H
#define ENCODER_SW_SINGLE_H

#include <project.h>

/*encoder hardware*/       
#define NUMBER_OF_DETENT  20     // 32 for Ppansonic EVEQ, 20 for my Alps
#define NUMBER_OF_PULSE   20     // 16 for Ppansonic EVEQ, 20 for my Alps
    
#define INITIAL_COUNTER  0x8000  // InitialCounter
    
#define ENCODER_MODE ((4 * NUMBER_OF_PULSE / NUMBER_OF_DETENT))  //Number of counts of detent 
    
/*--------rotary encoder struct----------*/
typedef struct encoder{
    uint8 encoderMode;      //actual encoder mode
    uint16 counterValue;    //actual counter
    uint8 switchPressed;    //status of encoder switch
    uint8 switchCount;      //number ob button pressed (if needed)
    char  direction;        //encoder direction (if needed)
    uint8 sLast;            //last state
} ENCODER_t;

extern ENCODER_t myEncoder; 
extern uint32 encScanTimer; //polling timer   

void encoder_init(void);    
uint8 encoder_update(void);    

#endif

/* [] END OF FILE */
